"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = asPrimaryExport;

var React = _interopRequireWildcard(require("react"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

/*
Copyright (c) 2018 Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/
// transforms props for native styled components adding $ symbol to avoid to supported warning
function asPrimaryExport(StyledComponent, propsTransformNames) {
  return function withStyledPropsHOC(props) {
    var styledProps = Object.keys(props).reduce(function (acc, key) {
      if (key[0] === '$' || propsTransformNames.indexOf(key) < 0) {
        acc[key] = props[key];
      } else if (propsTransformNames.indexOf(key) >= 0) {
        acc['$' + key] = props[key];
      }

      return acc;
    }, {});
    return React.createElement(StyledComponent, styledProps);
  };
}