"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.H1 = H1;
exports.H2 = H2;
exports.H3 = H3;
exports.H4 = H4;
exports.H5 = H5;
exports.H6 = H6;
exports.Paragraph1 = Paragraph1;
exports.Paragraph2 = Paragraph2;
exports.Label2 = exports.Label1 = exports.Display = exports.Caption2 = exports.Caption1 = void 0;

var _react = _interopRequireDefault(require("react"));

var _block = _interopRequireDefault(require("../block/block.js"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

// Captions - aka Caption, CaptionLabel
var Caption1 = function Caption1(props) {
  return _react.default.createElement(_block.default, _extends({
    "data-baseweb": "typo-caption1"
  }, props, {
    font: props.font || 'font200',
    color: props.color || 'colorSecondary'
  }));
};

exports.Caption1 = Caption1;

var Caption2 = function Caption2(props) {
  return _react.default.createElement(_block.default, _extends({
    "data-baseweb": "typo-caption2"
  }, props, {
    font: props.font || 'font250',
    color: props.color || 'colorSecondary'
  }));
}; // Display


exports.Caption2 = Caption2;

var Display = function Display(props) {
  return _react.default.createElement(_block.default, _extends({
    "data-baseweb": "typo-display"
  }, props, {
    font: props.font || 'font1100',
    color: props.color || 'colorPrimary'
  }));
}; // Headings


exports.Display = Display;

function H1(props) {
  var as = props.as || 'h1';
  return _react.default.createElement(_block.default, _extends({
    "data-baseweb": "typo-h1",
    as: as
  }, props, {
    font: props.font || 'font1000',
    color: props.color || 'colorPrimary'
  }));
}

function H2(props) {
  var as = props.as || 'h2';
  return _react.default.createElement(_block.default, _extends({
    "data-baseweb": "typo-h2",
    as: as
  }, props, {
    font: props.font || 'font900',
    color: props.color || 'colorPrimary'
  }));
}

function H3(props) {
  var as = props.as || 'h3';
  return _react.default.createElement(_block.default, _extends({
    "data-baseweb": "typo-h3",
    as: as
  }, props, {
    font: props.font || 'font800',
    color: props.color || 'colorPrimary'
  }));
}

function H4(props) {
  var as = props.as || 'h4';
  return _react.default.createElement(_block.default, _extends({
    "data-baseweb": "typo-h4",
    as: as
  }, props, {
    font: props.font || 'font700',
    color: props.color || 'colorPrimary'
  }));
}

function H5(props) {
  var as = props.as || 'h5';
  return _react.default.createElement(_block.default, _extends({
    "data-baseweb": "typo-h5",
    as: as
  }, props, {
    font: props.font || 'font600',
    color: props.color || 'colorPrimary'
  }));
}

function H6(props) {
  var as = props.as || 'h6';
  return _react.default.createElement(_block.default, _extends({
    "data-baseweb": "typo-h6",
    as: as
  }, props, {
    font: props.font || 'font500',
    color: props.color || 'colorPrimary'
  }));
} // Labels - aka Label1, Label2


var Label1 = function Label1(props) {
  return _react.default.createElement(_block.default, _extends({
    "data-baseweb": "typo-label1"
  }, props, {
    font: props.font || 'font350',
    color: props.color || 'colorPrimary'
  }));
};

exports.Label1 = Label1;

var Label2 = function Label2(props) {
  return _react.default.createElement(_block.default, _extends({
    "data-baseweb": "typo-label2"
  }, props, {
    font: props.font || 'font450',
    color: props.color || 'colorPrimary'
  }));
}; // Paragraphs - Paragraph1, Paragraph2


exports.Label2 = Label2;

function Paragraph1(props) {
  var as = props.as || 'p';
  return _react.default.createElement(_block.default, _extends({
    "data-baseweb": "typo-p1",
    as: as
  }, props, {
    font: props.font || 'font300',
    color: props.color || 'colorPrimary'
  }));
}

function Paragraph2(props) {
  var as = props.as || 'p';
  return _react.default.createElement(_block.default, _extends({
    "data-baseweb": "typo-p2",
    as: as
  }, props, {
    font: props.font || 'font400',
    color: props.color || 'colorPrimary'
  }));
}